

/* This file is for struct definitions that are
 * ONLY USED in hpt.c.
 * Nothing else should include this file.
 */

/**********************************************************************
 * Here starts the solaris-standard struct definitions that we
 * have to use
 *
 **********************************************************************/

/* "char/block operations" */
/* maybe we need a bus_ops, too?!! */
static struct cb_ops	hpt_cb_ops = {
	hpt_open,		/* open() */
	hpt_close,		/* close() */
	hpt_strategy,		/* strategy()		*/
	hpt_devprint,		/* no print routine	*/
	nodev,			/* no dump routine	*/
	hpt_read,		/* read() */
	hpt_write,		/* write() */

	hpt_ioctl,		/* generic ioctl */
	nodev,			/* no devmap routine	*/
	nodev,			/* no mmap routine	*/

#ifdef USE_DEVMAP
	ddi_devmap_segmap,		/*  segmap routine, to allow mmap()*/
#else
	nodev,			/* no segmap routine	*/
#endif
	nochpoll,		/* no chpoll routine	*/
	hpt_prop,
	0,			/* not a STREAMS driver	*/
	D_NEW | D_MP,		/* safe for multi-thread/multi-processor */
	0,			/* cb_ops version? */
	hpt_aread,		/* cb_aread() */
	hpt_awrite,		/* cb_awrite() */
};

#ifdef USEBUS
/* This is UNDOCUMENTED STUFF. ooOOOoo... */
static struct bus_ops hpt_bus_ops = {
	BUSO_REV_3,
	nodev,		/* bus_map */
	nodev,		/* bus_get_intrspec */
	nodev,		/* bus_add_intrspec */
	nodev,		/* bus_remove_intrspec */
	nodev,		/* bus_map_fault */
	nodev,		/* bus_dma_map */
	nodev,		/* bus_dma_allochdl */
	nodev,		/* bus_dma_freehdl */
	nodev,		/* bus_dma_bindhdl */
	nodev,		/* bus_dma_unbindhdl */
	nodev,		/* bus_dma_flush */
	nodev,		/* bus_dma_win */
	nodev,		/* bus_dma_ctl */
	nodev,		/* bus_ctl */
	nodev,		/* bus_prop_op */

	nodev,		/* bus_get_eventcookie */
	nodev,		/* bus_get_eventcall */
	nodev		/* bus_post_event */


};

#endif


/* "device operations". */
static struct dev_ops hpt_ops = {
	DEVO_REV,		/* devo_rev */
	0,			/* devo_refcnt */
	hpt_getinfo,		/* devo_getinfo */
	nulldev,		/* devo_identify */
	nulldev,		/* devo_probe */
	hpt_attach,		/* devo_attach */
	hpt_detach,		/* devo_detach */
	nodev,			/* devo_reset */
	&hpt_cb_ops,		/* devo_cb_ops */
#ifdef USEBUS
	&hpt_bus_ops,		/* devo_cb_ops */
#else
	NULL,		/* devo_cb_ops */
#endif
	NULL,			/* devo_power */
};

/* Ignore this. This is only a filler for the next struct, and
 * is already declared in modctl.h
 */
extern	struct	mod_ops mod_driverops;

static	struct modldrv modldrv = {
	&mod_driverops,
	"HPT366 UDMA v0.2, bolthole.com",
	&hpt_ops,
};

static	struct modlinkage modlinkage = {
	MODREV_1,		/* MODREV_1 indicated by manual */
	{
		(void *)&modldrv,
		NULL		/* termination of list of linkage structures */
	}
};


/* semi-prefilled info struct for DKIOCINFO */
static struct dk_cinfo controllerinfo ={
	"hpt",		/* controller name */
	DKC_DIRECT,		/* controller type */
	0,			/* flags */
	0,			/* number */
	0,			/* controller address?!! */
	0,			/* bus type */
	0,			/* interrupt priority */
	0,			/* interrupt vector */
	"hpt",			/* disk driver name */
	0,			/* unit # */
	0,			/* slavenum */
	0,			/* partitionnum */
#ifdef SHORTSIZE
	/* Tweak to see if limiting transfer sizes to 1 page helps.
	 *  (It doesnt)
	 */
	(4096 / DEV_BSIZE)	/* maxtransfer,units of (DEV_BSIZE) */
#else
	(65536 / DEV_BSIZE)	/* maxtransfer,units of (DEV_BSIZE) */
#endif

};

