/* This routine exists solely to trigger debug_info() in the driver */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <errno.h>

char *DEV="/devices/pci@0,0/pci1103,4@13:hpt0D0,raw";

void usage(){
	puts("Usage: debughpt [-r|-u|-i] [-d /path/to/RAWdev]");
	printf("eg: debughpt -d %s\n",DEV);
	puts("-i  PEEK");
	puts("-u  UNSTICK");
	puts("-r  RESET");
	puts("-f  IDENTIFY");
}

enum mode {NOTHING=0,PEEK,UNSTICK,RESET, IDENTIFY};

int main(int argc, char *argv[]){
	int fd, optchar;
	int ioctlnum=PEEK; 
	

	while((optchar = getopt(argc,argv,"iurfd:")) != EOF){
		switch(optchar){
		    case 'i':
			ioctlnum=PEEK;
			break;
		    case 'u':
			ioctlnum=UNSTICK;
			break;
		    case 'r':
			ioctlnum=RESET;
			break;
		    case 'f':
			ioctlnum=IDENTIFY;
			break;
		    case 'd':
			DEV=optarg;
			printf("dev set to %s\n",DEV);
			break;
		    default:
			usage();
			exit(1);
		}
	}

	printf("Opening device %s\n",DEV);
	fd=open(DEV,O_RDWR);
	if(fd<0){
		perror("could not open device");
		exit(errno);
	}

	if(ioctl(fd,ioctlnum) !=0){
		puts("ioctl FAILED??");
	} else {
		puts("ioctl sent");
	}
	close(fd);

	return 0;
}
