/* unlike "testwrite", this will just write blocks with a numerical ID.
 * "testwrite" will go back and verify the limited blocks it writes
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <errno.h>

int main(int argc, char *argv[]){
	char buffer[10000];
	int bytecount=8192;
	int block=0, loop;
	int fd, rcount,maxblock;
	char *DEV;
	/*char *DEV="/devices/pci@0,0/pci1103,4@13:hpt0D0";*/

	if(argc<3){
		puts("You must give a device to WRITE to");
		puts("and number of blocks to label");
		exit(1);
	}
	DEV=argv[1];
	maxblock=atoi(argv[2]);
	fprintf(stderr,"Using device %s\n",DEV);
	fd=open(DEV,O_WRONLY);
	if(fd<0){
		perror("could not open device");
		exit(errno);
	}


	while(block<maxblock){
		memset(buffer,0,8192);
		
		for(loop=0;loop<16;loop++){
			sprintf(&buffer[loop*512],"block %d",block+loop);
		}

		fprintf(stderr,"writing %d bytes to dev\n",bytecount);
		rcount=write(fd,buffer,bytecount);
		if(rcount<bytecount){
			perror("bad write?");
			fprintf(stderr,"Only wrote %d chars\n",rcount);
			close(fd);
			exit(1);
		}
		block+=16;
	}
	

	puts("Writes completed");

	close(fd);

	return 0;
}
