#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <errno.h>

int main(int argc, char *argv[]){
	char buffer[10000];
	int bytecount=8192;
	int block;
	int fd, rcount;
	char *DEV;
	/*char *DEV="/devices/pci@0,0/pci1103,4@13:hpt0D0";*/

	if(argc<2){
		puts("You must give a device to WRITE to");
		puts("Will write 16 blocks to it");
		exit(1);
	}
	DEV=argv[1];

	fprintf(stderr,"Using device %s\n",DEV);
	memset(buffer,0,8192);
	fprintf(stderr,"initializing first 16 blocks in memory\n");
	for(block=0;block<16;block++){
		sprintf(&buffer[block*512],"block %d",block);
	}
	


	fd=open(DEV,O_WRONLY);
	if(fd<0){
		perror("could not open device");
		exit(errno);
	}

	fprintf(stderr,"writing %d bytes to dev\n",bytecount);
	rcount=write(fd,buffer,bytecount);
	if(rcount<bytecount){
		perror("bad write?");
		fprintf(stderr,"Only wrote %d chars\n",rcount);
		close(fd);
		exit(1);
	}
	close(fd);

	
	fprintf(stderr,"Wiping buffer\n",bytecount);
	memset(buffer,0,8192);
	
	fprintf(stderr,"closing, and now reopening device, for read\n");

	fd=open(DEV,O_RDONLY);
	if(fd<0){
		perror("could not open device");
		exit(errno);
	}

	fprintf(stderr,"reading %d bytes from dev: will dump to stdout\n",
		bytecount);
	rcount=read(fd,buffer,bytecount);
	if(rcount<1){
		perror("bad read?");
		fprintf(stderr,"Only read %d chars\n",rcount);
		close(fd);
		exit(1);
	}

	write(1,buffer,rcount);
	close(fd);

	return 0;
}
