#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/dkio.h>
#include <sys/vtoc.h>
#include <errno.h>

#include <stdio.h>

int main(int argc, char *argv[]){
	int  fd;
	struct dk_cinfo cinfo;

	if(argc<2){
		puts("Need name of  device!");
		exit(1);
	}
	fd=open(argv[1],O_RDONLY);

	if(fd==-1){
		perror("could not open device");
		exit(errno);
	}

	if(ioctl(fd, DKIOCINFO, &cinfo) != 0){
		perror("could not get info");
		exit(errno);
	}

	puts("here is the controller info");

	printf("  controllername=%s\n",cinfo.dki_cname);
	printf("  ctype=%d\n",cinfo.dki_ctype);
	printf("  flags=%d\n",cinfo.dki_flags);
	printf("  cnum=%d\n",cinfo.dki_cnum);
	printf("  prio=%d\n",cinfo.dki_prio);
	printf("  dname=%s\n",cinfo.dki_dname);
	printf("  unit=%d\n",cinfo.dki_unit);
	printf("  slave=%d\n",cinfo.dki_slave);



	return 0;
}
