#include <fcntl.h>
#include <sys/types.h>
#include <sys/dkio.h>
#include <sys/vtoc.h>
#include <errno.h>

#include <stdio.h>


int main(int argc, char *argv[]){
	int  fd;
	struct vtoc label;

	if(argc<2){
		puts("Need name of  device!");
		exit(1);
	}
	fd=open(argv[1],O_RDONLY);

	if(fd==-1){
		perror("could not open device");
		exit(errno);
	}

	if(ioctl(fd, DKIOCGVTOC, &label) != 0){
		perror("could not get vtoc");
		exit(errno);
	}


	puts("here is the vtoc we got");

	printf("bytespersector: %d\n", label.v_sectorsz);
	{
		int pc;
		printf("volume name %s\n",label.v_volume);
		for(pc=0;pc<8;pc++){
			printf("%d: startblock %d, size %d, type %d\n",
			pc,
			label.v_part[pc].p_start,
			label.v_part[pc].p_size,
			label.v_part[pc].p_tag);
		}
	}
	return 0;
}
