#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/dkio.h>
#include <sys/vtoc.h>
#include <errno.h>

#include <stdio.h>

int main(int argc, char *argv[]){
	int  fd;
	struct dk_geom geom;

	if(argc<2){
		puts("Need name of  device!");
		exit(1);
	}
	fd=open(argv[1],O_RDONLY);

	if(fd==-1){
		perror("could not open device");
		exit(errno);
	}

	if(ioctl(fd, DKIOCG_PHYGEOM, &geom) != 0){
		perror("could not get info");
		exit(errno);
	}

	puts("here is the geometry info");

	printf("  ncyl=%d\n",geom.dkg_ncyl);
	printf("  acyl=%d\n",geom.dkg_acyl);
	printf("  bcyl=%d\n",geom.dkg_bcyl);
	printf("  nhead=%d\n",geom.dkg_nhead);
	printf("  nsect=%d\n",geom.dkg_nsect);
	printf("  rpm=%d\n",geom.dkg_rpm);
	printf("  pcyl=%d\n",geom.dkg_pcyl);

	return 0;
}
