#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/dkio.h>
#include <sys/dktp/dadkio.h>
#include <sys/vtoc.h>
#include <errno.h>

#include <stdio.h>

int main(int argc, char *argv[]){
	int  fd;
	int blknum;
	struct dadkio_rwcmd iostruct;
	char buffer[1024];
	int readstat;

	iostruct.cmd=DADKIO_RWCMD_READ;
	iostruct.flags=0;
	iostruct.bufaddr=buffer;
	iostruct.buflen=512;
	

	if(argc<3){
		fprintf(stderr,"Need name of  device, and blknum to read!\n");
		exit(1);
	}
	blknum=atoi(argv[2]);
	iostruct.blkaddr=blknum;

	fd=open(argv[1],O_RDONLY);

	if(fd==-1){
		perror("could not open device");
		exit(errno);
	}

	fprintf(stderr,"Trying for block number %d on %s\n",blknum,argv[1]);

	
	readstat=ioctl(fd, DIOCTL_RWCMD, &iostruct);
	if(readstat != 0){
		perror("could not read block");
		exit(errno);
	}


	fprintf(stderr,"Read successfully\n");
	write(1,buffer,512);

	return 0;
}
